diff --git a/ltt/probes/ltt-probe-list.c b/ltt/probes/ltt-probe-list.c
new file mode 100644
index 0000000..e8a06c1
--- /dev/null
+++ b/ltt/probes/ltt-probe-list.c
@@ -0,0 +1,109 @@
+/*
+ * ltt-probe-list.c
+ *
+ * list probe
+ *
+ * Part of LTTng
+ *
+ * Mathieu Desnoyers, March 2007
+ *
+ * Licensed under the GPLv2.
+ */
+
+#include <linux/kernel.h>
+#include <linux/module.h>
+#include <linux/crc32.h>
+#include <linux/marker.h>
+#include <linux/ltt-facilities.h>
+#include <linux/ltt-tracer.h>
+
+
+#define FACILITY_NAME "list"
+
+static struct ltt_probe_data probe_array[] =
+{
+	{ "list_module", "%s %d %lu", GET_CHANNEL_INDEX(modules) },
+	{ "list_file_descriptor", "%s %d %u", GET_CHANNEL_INDEX(cpu) },
+	{ "list_vm_map", "%d %lu %lu %lu %lu %lu", GET_CHANNEL_INDEX(cpu) },
+	{ "list_interrupt", "%s %s %u", GET_CHANNEL_INDEX(interrupts) },
+	{ "list_process_state", "%d %d %s %d %d %d %d %d",
+		GET_CHANNEL_INDEX(processes) },
+	{ "list_network_ip_interface", "%s %4b %d",
+		GET_CHANNEL_INDEX(network) },
+};
+
+
+#define NUM_PROBES (sizeof(probe_array) / sizeof(struct ltt_probe_data))
+
+static struct ltt_facility facility = {
+	.name = FACILITY_NAME,
+	.num_events = NUM_PROBES,
+	.checksum = 0,
+	.id = 0xFF,
+	.alignment = 1,	/* 1: true, 0: false */
+};
+
+static int __init probe_init(void)
+{
+	int result;
+	uint8_t eID;
+	int ret;
+
+	/* FIXME : LTTV is unable to compute this CRC (for now) */
+	for (eID = 0; eID < NUM_PROBES; eID++) {
+		facility.checksum =
+			crc32(facility.checksum, probe_array[eID].name,
+				strlen(probe_array[eID].name));
+		facility.checksum =
+			crc32(facility.checksum, probe_array[eID].format,
+				strlen(probe_array[eID].format));
+
+	}
+	ret = ltt_facility_kernel_register(&facility);
+	if (ret < 0) {
+		printk(KERN_WARNING "LTT : Error in registering facility %s\n",
+			facility.name);
+		return ret;
+	}
+	facility.id = (uint8_t)ret;
+
+	printk("LTT : Facility %s registered with id %hu\n", facility.name,
+		facility.id);
+
+	for (eID = 0; eID < NUM_PROBES; eID++) {
+		probe_array[eID].fID = facility.id;
+		probe_array[eID].eID = eID;
+		probe_array[eID].align = facility.alignment;
+		probe_array[eID].callbacks[0] = ltt_serialize_data;
+		result = marker_set_probe(probe_array[eID].name,
+				probe_array[eID].format,
+				ltt_trace, &probe_array[eID]);
+		if (!result)
+			printk(KERN_INFO "LTT unable to register probe %s\n",
+				probe_array[eID].name);
+	}
+	return 0;
+}
+
+static void __exit probe_fini(void)
+{
+	uint8_t eID;
+	int err;
+
+	for (eID = 0; eID < NUM_PROBES; eID++) {
+		marker_remove_probe(probe_array[eID].name);
+	}
+	synchronize_sched();	/* Wait for probes to finish */
+	err = ltt_facility_unregister(facility.id);
+	if (err)
+		printk(KERN_WARNING
+			"LTT : Error in unregistering facility %s\n",
+			facility.name);
+}
+
+module_init(probe_init);
+module_exit(probe_fini);
+
+MODULE_LICENSE("GPL");
+MODULE_AUTHOR("Mathieu Desnoyers");
+MODULE_DESCRIPTION(FACILITY_NAME " probe");
diff --git a/ltt/probes/ltt-probe-locking.c b/ltt/probes/ltt-probe-locking.c
new file mode 100644
index 0000000..3e28955
--- /dev/null
+++ b/ltt/probes/ltt-probe-locking.c
@@ -0,0 +1,114 @@
+/*
+ * ltt-probe-locking.c
+ *
+ * locking probe
+ *
+ * Part of LTTng
+ *
+ * Mathieu Desnoyers, March 2007
+ *
+ * Licensed under the GPLv2.
+ */
+
+#include <linux/kernel.h>
+#include <linux/module.h>
+#include <linux/crc32.h>
+#include <linux/marker.h>
+#include <linux/ltt-facilities.h>
+#include <linux/ltt-tracer.h>
+
+
+#define FACILITY_NAME "locking"
+
+static struct ltt_probe_data probe_array[] =
+{
+	{ "locking_hardirqs_on", "%lu", GET_CHANNEL_INDEX(cpu),
+		_MF_DEFAULT & ~_MF_LOCKDEP },
+	{ "locking_hardirqs_off", "%lu", GET_CHANNEL_INDEX(cpu),
+		_MF_DEFAULT & ~_MF_LOCKDEP },
+	{ "locking_softirqs_on", "%lu", GET_CHANNEL_INDEX(cpu),
+		_MF_DEFAULT & ~_MF_LOCKDEP },
+	{ "locking_softirqs_off", "%lu", GET_CHANNEL_INDEX(cpu),
+		_MF_DEFAULT & ~_MF_LOCKDEP },
+	{ "locking_lock_acquire", "%lu %u %p %d", GET_CHANNEL_INDEX(cpu),
+		_MF_DEFAULT & ~_MF_LOCKDEP },
+	{ "locking_lock_release", "%lu %p %d", GET_CHANNEL_INDEX(cpu),
+		_MF_DEFAULT & ~_MF_LOCKDEP },
+};
+
+
+#define NUM_PROBES (sizeof(probe_array) / sizeof(struct ltt_probe_data))
+
+static struct ltt_facility facility = {
+	.name = FACILITY_NAME,
+	.num_events = NUM_PROBES,
+	.checksum = 0,
+	.id = 0xFF,
+	.alignment = 1,	/* 1: true, 0: false */
+};
+
+static int __init probe_init(void)
+{
+	int result;
+	uint8_t eID;
+	int ret;
+
+	/* FIXME : LTTV is unable to compute this CRC (for now) */
+	for (eID = 0; eID < NUM_PROBES; eID++) {
+		facility.checksum =
+			crc32(facility.checksum, probe_array[eID].name,
+				strlen(probe_array[eID].name));
+		facility.checksum =
+			crc32(facility.checksum, probe_array[eID].format,
+				strlen(probe_array[eID].format));
+
+	}
+	ret = ltt_facility_kernel_register(&facility);
+	if (ret < 0) {
+		printk(KERN_WARNING "LTT : Error in registering facility %s\n",
+			facility.name);
+		return ret;
+	}
+	facility.id = (uint8_t)ret;
+
+	printk("LTT : Facility %s registered with id %hu\n", facility.name,
+		facility.id);
+
+	for (eID = 0; eID < NUM_PROBES; eID++) {
+		probe_array[eID].fID = facility.id;
+		probe_array[eID].eID = eID;
+		probe_array[eID].align = facility.alignment;
+		probe_array[eID].callbacks[0] = ltt_serialize_data;
+		result = _marker_set_probe(probe_array[eID].flags,
+				probe_array[eID].name,
+				probe_array[eID].format,
+				ltt_trace, &probe_array[eID]);
+		if (!result)
+			printk(KERN_INFO "LTT unable to register probe %s\n",
+				probe_array[eID].name);
+	}
+	return 0;
+}
+
+static void __exit probe_fini(void)
+{
+	uint8_t eID;
+	int err;
+
+	for (eID = 0; eID < NUM_PROBES; eID++) {
+		marker_remove_probe(probe_array[eID].name);
+	}
+	synchronize_sched();	/* Wait for probes to finish */
+	err = ltt_facility_unregister(facility.id);
+	if (err)
+		printk(KERN_WARNING
+			"LTT : Error in unregistering facility %s\n",
+			facility.name);
+}
+
+module_init(probe_init);
+module_exit(probe_fini);
+
+MODULE_LICENSE("GPL");
+MODULE_AUTHOR("Mathieu Desnoyers");
+MODULE_DESCRIPTION(FACILITY_NAME " probe");
diff --git a/ltt/probes/ltt-probe-mm.c b/ltt/probes/ltt-probe-mm.c
new file mode 100644
index 0000000..a0376be
--- /dev/null
+++ b/ltt/probes/ltt-probe-mm.c
@@ -0,0 +1,109 @@
+/*
+ * ltt-probe-mm.c
+ *
+ * mm probe
+ *
+ * Part of LTTng
+ *
+ * Mathieu Desnoyers, March 2007
+ *
+ * Licensed under the GPLv2.
+ */
+
+#include <linux/kernel.h>
+#include <linux/module.h>
+#include <linux/crc32.h>
+#include <linux/marker.h>
+#include <linux/ltt-facilities.h>
+#include <linux/ltt-tracer.h>
+
+
+#define FACILITY_NAME "mm"
+
+static struct ltt_probe_data probe_array[] =
+{
+	{ "mm_handle_fault_entry", "%lu %ld", GET_CHANNEL_INDEX(cpu) },
+	{ "mm_handle_fault_exit", MARK_NOARGS, GET_CHANNEL_INDEX(cpu) },
+	{ "mm_filemap_wait_start", "%p", GET_CHANNEL_INDEX(cpu) },
+	{ "mm_filemap_wait_end", "%p", GET_CHANNEL_INDEX(cpu) },
+	{ "mm_page_alloc", "%u %p", GET_CHANNEL_INDEX(cpu) },
+	{ "mm_page_free", "%u %p", GET_CHANNEL_INDEX(cpu) },
+	{ "mm_swap_in", "%lu", GET_CHANNEL_INDEX(cpu) },
+	{ "mm_swap_out", "%p", GET_CHANNEL_INDEX(cpu) },
+};
+
+
+#define NUM_PROBES (sizeof(probe_array) / sizeof(struct ltt_probe_data))
+
+static struct ltt_facility facility = {
+	.name = FACILITY_NAME,
+	.num_events = NUM_PROBES,
+	.checksum = 0,
+	.id = 0xFF,
+	.alignment = 1,	/* 1: true, 0: false */
+};
+
+static int __init probe_init(void)
+{
+	int result;
+	uint8_t eID;
+	int ret;
+
+	/* FIXME : LTTV is unable to compute this CRC (for now) */
+	for (eID = 0; eID < NUM_PROBES; eID++) {
+		facility.checksum =
+			crc32(facility.checksum, probe_array[eID].name,
+				strlen(probe_array[eID].name));
+		facility.checksum =
+			crc32(facility.checksum, probe_array[eID].format,
+				strlen(probe_array[eID].format));
+
+	}
+	ret = ltt_facility_kernel_register(&facility);
+	if (ret < 0) {
+		printk(KERN_WARNING "LTT : Error in registering facility %s\n",
+			facility.name);
+		return ret;
+	}
+	facility.id = (uint8_t)ret;
+
+	printk("LTT : Facility %s registered with id %hu\n", facility.name,
+		facility.id);
+
+	for (eID = 0; eID < NUM_PROBES; eID++) {
+		probe_array[eID].fID = facility.id;
+		probe_array[eID].eID = eID;
+		probe_array[eID].align = facility.alignment;
+		probe_array[eID].callbacks[0] = ltt_serialize_data;
+		result = marker_set_probe(probe_array[eID].name,
+				probe_array[eID].format,
+				ltt_trace, &probe_array[eID]);
+		if (!result)
+			printk(KERN_INFO "LTT unable to register probe %s\n",
+				probe_array[eID].name);
+	}
+	return 0;
+}
+
+static void __exit probe_fini(void)
+{
+	uint8_t eID;
+	int err;
+
+	for (eID = 0; eID < NUM_PROBES; eID++) {
+		marker_remove_probe(probe_array[eID].name);
+	}
+	synchronize_sched();	/* Wait for probes to finish */
+	err = ltt_facility_unregister(facility.id);
+	if (err)
+		printk(KERN_WARNING
+			"LTT : Error in unregistering facility %s\n",
+			facility.name);
+}
+
+module_init(probe_init);
+module_exit(probe_fini);
+
+MODULE_LICENSE("GPL");
+MODULE_AUTHOR("Mathieu Desnoyers");
+MODULE_DESCRIPTION(FACILITY_NAME " probe");
diff --git a/ltt/probes/ltt-probe-net.c b/ltt/probes/ltt-probe-net.c
new file mode 100644
index 0000000..e093055
--- /dev/null
+++ b/ltt/probes/ltt-probe-net.c
@@ -0,0 +1,109 @@
+/*
+ * ltt-probe-net.c
+ *
+ * Network probe
+ *
+ * Part of LTTng
+ *
+ * Mathieu Desnoyers, March 2007
+ *
+ * Licensed under the GPLv2.
+ */
+
+#include <linux/kernel.h>
+#include <linux/module.h>
+#include <linux/crc32.h>
+#include <linux/marker.h>
+#include <linux/ltt-facilities.h>
+#include <linux/ltt-tracer.h>
+
+
+#define FACILITY_NAME "net"
+
+static struct ltt_probe_data probe_array[] =
+{
+	{ "net_socket_sendmsg", "%p %d %d %d %zu", GET_CHANNEL_INDEX(cpu) },
+	{ "net_socket_recvmsg", "%p %d %d %d %zu", GET_CHANNEL_INDEX(cpu) },
+	{ "net_socket_create", "%p %d %d %d %d", GET_CHANNEL_INDEX(cpu) },
+	{ "net_socket_call", "%d %lu", GET_CHANNEL_INDEX(cpu) },
+	{ "net_dev_xmit", "%p %2b", GET_CHANNEL_INDEX(cpu) },
+	{ "net_dev_receive", "%p %2b", GET_CHANNEL_INDEX(cpu) },
+	{ "net_insert_ifa", "%s %4b", GET_CHANNEL_INDEX(network) },
+	{ "net_del_ifa", "%s", GET_CHANNEL_INDEX(network) },
+};
+
+
+#define NUM_PROBES (sizeof(probe_array) / sizeof(struct ltt_probe_data))
+
+static struct ltt_facility facility = {
+	.name = FACILITY_NAME,
+	.num_events = NUM_PROBES,
+	.checksum = 0,
+	.id = 0xFF,
+	.alignment = 1,	/* 1: true, 0: false */
+};
+
+static int __init probe_init(void)
+{
+	int result;
+	uint8_t eID;
+	int ret;
+
+	/* FIXME : LTTV is unable to compute this CRC (for now) */
+	for (eID = 0; eID < NUM_PROBES; eID++) {
+		facility.checksum =
+			crc32(facility.checksum, probe_array[eID].name,
+				strlen(probe_array[eID].name));
+		facility.checksum =
+			crc32(facility.checksum, probe_array[eID].format,
+				strlen(probe_array[eID].format));
+
+	}
+	ret = ltt_facility_kernel_register(&facility);
+	if (ret < 0) {
+		printk(KERN_WARNING "LTT : Error in registering facility %s\n",
+			facility.name);
+		return ret;
+	}
+	facility.id = (uint8_t)ret;
+
+	printk("LTT : Facility %s registered with id %hu\n", facility.name,
+		facility.id);
+
+	for (eID = 0; eID < NUM_PROBES; eID++) {
+		probe_array[eID].fID = facility.id;
+		probe_array[eID].eID = eID;
+		probe_array[eID].align = facility.alignment;
+		probe_array[eID].callbacks[0] = ltt_serialize_data;
+		result = marker_set_probe(probe_array[eID].name,
+				probe_array[eID].format,
+				ltt_trace, &probe_array[eID]);
+		if (!result)
+			printk(KERN_INFO "LTT unable to register probe %s\n",
+				probe_array[eID].name);
+	}
+	return 0;
+}
+
+static void __exit probe_fini(void)
+{
+	uint8_t eID;
+	int err;
+
+	for (eID = 0; eID < NUM_PROBES; eID++) {
+		marker_remove_probe(probe_array[eID].name);
+	}
+	synchronize_sched();	/* Wait for probes to finish */
+	err = ltt_facility_unregister(facility.id);
+	if (err)
+		printk(KERN_WARNING
+			"LTT : Error in unregistering facility %s\n",
+			facility.name);
+}
+
+module_init(probe_init);
+module_exit(probe_fini);
+
+MODULE_LICENSE("GPL");
+MODULE_AUTHOR("Mathieu Desnoyers");
+MODULE_DESCRIPTION(FACILITY_NAME " probe");
diff --git a/ltt/probes/ltt-probe-stack_arch_i386.c b/ltt/probes/ltt-probe-stack_arch_i386.c
new file mode 100644
index 0000000..f650b95
--- /dev/null
+++ b/ltt/probes/ltt-probe-stack_arch_i386.c
@@ -0,0 +1,412 @@
+/*
+ * ltt-probe-stack_arch_i386.c
+ *
+ * stack arch i386 probe
+ *
+ * Part of LTTng
+ *
+ * Mathieu Desnoyers, March 2007
+ *
+ * Licensed under the GPLv2.
+ */
+
+#include <linux/kernel.h>
+#include <linux/module.h>
+#include <linux/crc32.h>
+#include <linux/marker.h>
+#include <linux/ltt-facilities.h>
+#include <linux/ptrace.h>
+#include <linux/ltt-tracer.h>
+
+struct stack_dump_args {
+	unsigned long ebp;
+};
+
+/* Kernel specific trace stack dump routines, from arch/i386/kernel/traps.c */
+
+/* Event kernel_dump structures 
+ * ONLY USE IT ON THE CURRENT STACK.
+ * It does not protect against other stack modifications and _will_
+ * cause corruption upon race between threads.
+ *
+ * FIXME : using __kernel_text_address here can break things if a module is
+ * loaded during tracing. The real function pointers are OK : if they are on our
+ * stack, it means that the module refcount must not be 0, but the problem comes
+ * from the "false positives" : that that appears to be a function pointer.
+ * The solution to this problem : 
+ * Without frame pointers, we have one version with spinlock irqsave (never call
+ * this in NMI context, and another with a trylock, which can fail. */
+
+static inline int dump_valid_stack_ptr(struct thread_info *tinfo, void *p)
+{
+	return	p > (void *)tinfo &&
+		p < (void *)tinfo + THREAD_SIZE - 3;
+}
+
+/* norm : inline */
+static noinline unsigned long dump_context_stack(struct thread_info *tinfo,
+		unsigned long *stack, unsigned long ebp,
+		char *buffer,
+		char **str,
+		long *len)
+{
+	unsigned long addr;
+
+#ifdef	CONFIG_FRAME_POINTER
+	while (dump_valid_stack_ptr(tinfo, (void *)ebp)) {
+		unsigned long new_ebp;
+		if (buffer != NULL) {
+			unsigned long *dest = (unsigned long*)*str;
+			addr = *(unsigned long *)(ebp + 4);
+			*dest = addr;
+		} else {
+			(*len)++;
+		}
+		(*str) += sizeof(unsigned long);
+		new_ebp = *(unsigned long *)ebp;
+		if (new_ebp <= ebp)
+			break;
+		ebp = new_ebp;
+	}
+#else
+	while (dump_valid_stack_ptr(tinfo, stack)) {
+		addr = *stack++;
+		if (__kernel_text_address(addr)) {
+			if (buffer != NULL) {
+				unsigned long *dest = (unsigned long*)*str;
+				*dest = addr;
+			} else {
+				(*len)++;
+			}
+			(*str) += sizeof(unsigned long);
+		}
+	}
+#endif
+	return ebp;
+}
+
+static noinline void dump_trace(unsigned long * stack,
+		unsigned long ebp,
+		char *buffer,
+		char **str,
+		long *len)
+{
+	while (1) {
+		struct thread_info *context;
+		context = (struct thread_info *)
+			((unsigned long)stack & (~(THREAD_SIZE - 1)));
+		ebp = dump_context_stack(context, stack, ebp,
+				buffer, str, len);
+		stack = (unsigned long*)context->previous_esp;
+		if (!stack)
+			break;
+	}
+}
+
+static noinline char *ltt_serialize_kernel_stack(char *buffer, char *str,
+	struct ltt_serialize_closure *closure,
+	int align, const char *fmt, va_list *args)
+{
+	struct stack_dump_args *stargs;
+
+	/* Ugly and crude argument passing hack part 2. */
+	stargs = (struct stack_dump_args *)fmt;
+
+	if (align)
+		str += ltt_align((long)str,
+			max(sizeof(int), sizeof(unsigned long)));
+	if (buffer)
+		*(int*)str = (int)closure->cb_args[0];
+	str += sizeof(int);
+
+	if (!buffer)
+		closure->cb_args[0] = 0;
+
+	if (align)
+		str += ltt_align((long)str, sizeof(unsigned long));
+	dump_trace((unsigned long*)stargs, stargs->ebp, buffer, &str,
+			&closure->cb_args[0]);
+
+	/* Following alignment for genevent
+	 * compatibility */
+	if (align)
+		str += ltt_align((long)str, sizeof(void*));
+	return str;
+}
+
+/* Expects va args : (struct pt_regs *regs) */
+static void ltt_trace_kernel_stack(const struct __mark_marker_data *mdata,
+	const char *fmt, ...)
+{
+	struct stack_dump_args stargs;
+	va_list args;
+	struct pt_regs *regs;
+
+#ifndef CONFIG_LTT_KERNEL_STACK
+	return;
+#endif
+
+	va_start(args, fmt);
+	regs = va_arg(args, struct pt_regs *);
+	if (unlikely(!regs || user_mode_vm(regs)))
+		goto end;
+	/* Grab ebp right from our regs */
+	asm ("movl %%ebp, %0" : "=r" (stargs.ebp) : );
+	/* Ugly and crude argument passing hack part 1. */
+	ltt_vtrace(mdata, (const char*)&stargs, args);
+end:
+	va_end(args);
+}
+
+/* FIXME : how could we autodetect this.... ?!? disabled for now. */
+static noinline void dump_fp_process_stack(
+		struct pt_regs *regs,
+		char *buffer,
+		char **str,
+		long *len)
+{
+	uint32_t addr;
+	uint32_t next_ebp;
+	uint32_t *iter;
+	uint32_t *dest = (uint32_t*)*str;
+
+	if (buffer)
+		*dest = regs->eip;
+	else
+		(*len)++;
+	dest++;
+
+	/* Start at the topmost ebp */
+	iter = (uint32_t*)regs->ebp;
+
+	/* Keep on going until we reach the end of the process' stack limit or
+	 * find an invalid ebp. */
+	while (!get_user(next_ebp, iter)) {
+		/* If another thread corrupts the thread user space stack
+		 * concurrently */
+		if (buffer)
+			if (dest == (uint32_t*)(*str) + *len)
+				break;
+		if (next_ebp <= (uint32_t)(iter+1))
+			break;
+		if (buffer)
+			*dest = addr;
+		else
+			(*len)++;
+		dest++;
+		iter = (uint32_t*)next_ebp;
+	}
+
+	/* Concurrently been changed : pad with zero */
+	if (buffer)
+		while (dest < (uint32_t*)(*str) + *len) {
+			*dest = 0;
+			dest++;
+		}
+	*str = (char*)dest;
+}
+
+static noinline void dump_nofp_process_stack(
+		struct pt_regs *regs,
+		char *buffer,
+		char **str,
+		long *len)
+{
+	uint32_t addr;
+	uint32_t *iter;
+	uint32_t *dest = (uint32_t*)*str;
+	uint32_t *prev_iter, *beg_iter;
+
+	if (buffer)
+		*dest = regs->eip;
+	else
+		(*len)++;
+	dest++;
+
+	/* FIXME : currently detects code addresses from executable only,
+	 * not libraries */
+	/* Start at the top of the user stack */
+	prev_iter = beg_iter = iter = (uint32_t*) regs->esp;
+
+	while (!get_user(addr, iter)) {
+		if (buffer)
+			if (dest == (uint32_t*)(*str) + *len)
+				break;
+		/* Does this LOOK LIKE an address in the program */
+		if (addr > current->mm->start_code &&
+			addr < current->mm->end_code) {
+			if (buffer)
+				*dest = addr;
+			else
+				(*len)++;
+			dest++;
+		}
+		prev_iter = iter;
+		iter++;
+		if (iter >
+			prev_iter + CONFIG_LTT_PROCESS_MAX_FUNCTION_STACK)
+			break;
+		if (iter > beg_iter + CONFIG_LTT_PROCESS_MAX_STACK_LEN)
+			break;
+	}
+
+	/* Concurrently been changed : pad with zero */
+	if (buffer)
+		while (dest < (uint32_t*)(*str) + *len) {
+			*dest = 0;
+			dest++;
+		}
+	*str = (char*)dest;
+}
+
+static noinline char *ltt_serialize_process_stack(char *buffer, char *str,
+	struct ltt_serialize_closure *closure,
+	int align, const char *fmt, va_list *args)
+{
+	struct pt_regs *regs;
+
+	/* Ugly and crude argument passing hack part 2 (revisited). */
+	regs = (struct pt_regs *)fmt;
+
+	if (align)
+		str += ltt_align((long)str,
+			max(sizeof(int), sizeof(unsigned long)));
+	if (buffer)
+		*(int*)str = (int)closure->cb_args[0];
+	str += sizeof(int);
+
+	if (!buffer)
+		closure->cb_args[0] = 0;
+
+	if (align)
+		str += ltt_align((long)str, sizeof(unsigned long));
+	dump_nofp_process_stack(regs, buffer, &str, &closure->cb_args[0]);
+
+	/* Following alignment for genevent
+	 * compatibility */
+	if (align)
+		str += ltt_align((long)str, sizeof(void*));
+	return str;
+}
+
+/* Expects va args : (struct pt_regs *regs) */
+static void ltt_trace_process_stack(const struct __mark_marker_data *mdata,
+	const char *fmt, ...)
+{
+	va_list args;
+	struct pt_regs *regs;
+
+#ifndef CONFIG_LTT_PROCESS_STACK
+	return;
+#endif
+
+	va_start(args, fmt);
+	regs = va_arg(args, struct pt_regs *);
+	if (unlikely(!regs || !user_mode_vm(regs)))
+		goto end;
+	/* Ugly and crude argument passing hack part 1 (revisited). */
+	ltt_vtrace(mdata, (const char*)regs, args);
+end:
+	va_end(args);
+}
+
+#define FACILITY_NAME "stack_arch"
+
+static struct ltt_probe_data probe_array[] =
+{
+	{ "stack_arch_irq_dump_kernel_stack", MARK_NOARGS,
+		GET_CHANNEL_INDEX(cpu),
+		.probe_func = ltt_trace_kernel_stack,
+		.callbacks[0] = ltt_serialize_kernel_stack },
+	{ "stack_arch_nmi_dump_kernel_stack", MARK_NOARGS,
+		GET_CHANNEL_INDEX(cpu),
+		.probe_func = ltt_trace_kernel_stack,
+		.callbacks[0] = ltt_serialize_kernel_stack },
+	{ "stack_arch_syscall_dump_kernel_stack", MARK_NOARGS,
+		GET_CHANNEL_INDEX(cpu),
+		.probe_func = ltt_trace_kernel_stack,
+		.callbacks[0] = ltt_serialize_kernel_stack },
+	{ "stack_arch_irq_dump_process32_stack", MARK_NOARGS,
+		GET_CHANNEL_INDEX(cpu),
+		.probe_func = ltt_trace_process_stack,
+		.callbacks[0] = ltt_serialize_process_stack },
+	{ "stack_arch_syscall_dump_process32_stack", MARK_NOARGS,
+		GET_CHANNEL_INDEX(cpu),
+		.probe_func = ltt_trace_process_stack,
+		.callbacks[0] = ltt_serialize_process_stack },
+};
+
+
+#define NUM_PROBES (sizeof(probe_array) / sizeof(struct ltt_probe_data))
+
+static struct ltt_facility facility = {
+	.name = FACILITY_NAME,
+	.num_events = NUM_PROBES,
+	.checksum = 0,
+	.id = 0xFF,
+	.alignment = 1,	/* 1: true, 0: false */
+};
+
+static int __init probe_init(void)
+{
+	int result;
+	uint8_t eID;
+	int ret;
+
+	/* FIXME : LTTV is unable to compute this CRC (for now) */
+	for (eID = 0; eID < NUM_PROBES; eID++) {
+		facility.checksum =
+			crc32(facility.checksum, probe_array[eID].name,
+				strlen(probe_array[eID].name));
+		facility.checksum =
+			crc32(facility.checksum, probe_array[eID].format,
+				strlen(probe_array[eID].format));
+
+	}
+	ret = ltt_facility_kernel_register(&facility);
+	if (ret < 0) {
+		printk(KERN_WARNING "LTT : Error in registering facility %s\n",
+			facility.name);
+		return ret;
+	}
+	facility.id = (uint8_t)ret;
+
+	printk("LTT : Facility %s registered with id %hu\n", facility.name,
+		facility.id);
+
+	for (eID = 0; eID < NUM_PROBES; eID++) {
+		probe_array[eID].fID = facility.id;
+		probe_array[eID].eID = eID;
+		probe_array[eID].align = facility.alignment;
+		result = marker_set_probe(probe_array[eID].name,
+				probe_array[eID].format,
+				probe_array[eID].probe_func, &probe_array[eID]);
+		if (!result)
+			printk(KERN_INFO "LTT unable to register probe %s\n",
+				probe_array[eID].name);
+	}
+	return 0;
+}
+
+static void __exit probe_fini(void)
+{
+	uint8_t eID;
+	int err;
+
+	for (eID = 0; eID < NUM_PROBES; eID++) {
+		marker_remove_probe(probe_array[eID].name);
+	}
+	synchronize_sched();	/* Wait for probes to finish */
+	err = ltt_facility_unregister(facility.id);
+	if (err)
+		printk(KERN_WARNING
+			"LTT : Error in unregistering facility %s\n",
+			facility.name);
+}
+
+module_init(probe_init);
+module_exit(probe_fini);
+
+MODULE_LICENSE("GPL");
+MODULE_AUTHOR("Mathieu Desnoyers");
+MODULE_DESCRIPTION(FACILITY_NAME " probe");
